Option Explicit
' Version 1.2.1 - DateCreated and DateLastChange are now correct in the file name and no longer exchanged (2017-12-30)
' Version 1.2 - now the "ex_log.txt" in the EMAIL directory is now included in the ZIP
' Version 1.1 - added success message, and messages englified 
' *** english follows German ***
' Dies Script packt die aktuelle TheBat??_Exceptions.log im TheBat-Verzeichnis 
' in ein ZIP-Archiv, dessen Name mit der Version des aktuell installierten ausfhrbaren TheBat!
'  und den der Erzeugung und der letzten nderung der log-Datei ergnzt wird. 
' !!! Die Programmversion von TheBat! ist die des im Programmverzeichnis von The Bat! gefundenen Executables!
'     Man sollte also die Exception.log packen, bevor man die Exe von TheBat! mit einer neueren Version berschreibt
' Dazu ruft das Script ZIP.EXE auf mit dem Parameter -m, was das Lschen des log-files bewirkt. 
' ZIP.EXE wird irgendwo auf dem PATH erwartet. Runterladbar von www.zipinfo.org 
' *** english ***
' This script packs the current TheBat??_Exceptions.log from the TheBat directory into a ZIP archive.
' The name of the resulting ZIP includes the version of the TheBat! executable 
' currently found in the TheBat's programm directory and the timestamps of the log's creation and last change.
' !!! Since the TheBat!'s version used is that of the exe-file found in the program directory, 
'     you should ZIP the exception log before replacing that executable by a newer version, e.g. during a Beta test!
' This script requires ZIP.EXE to be on the path. Download ZIP.EXE from www.zipinfo.org (and its companion UNZIP.EXE).
' ...............................................................................................

Const testModus = False ' with testModus = True, this script does not change into the TheBat! user directory
Const suffix_Logfile = "_Exceptions"
Const extension_Logfile = ".log"
Dim BatPath, batBaseName, batVersion   ' from Registry, the file itself 
Dim Name_Logfile ' to be composed of base name of the TheBat! exexutable, suffix_Logfile and extension_Logfile
Dim fso, Shello, EnviroUser, logfile, logdir  ' Objekte  ... clippO, 
Dim ZIPtarget, cmdLine                    ' Strings
Dim zeitstempelCreate, zeitstempelChange  ' Strings 
Dim tagCreate, zeitCreate, tagChange, zeitChange  ' date-time werte 


set fso = CreateObject("Scripting.FileSystemObject")
Set Shello = WScript.CreateObject ("WSCript.shell")
Set EnviroUser = Shello.Environment("USER")
' Set clippO = CreateObject("WshExtra.Clipboard")   

BatPath = Shello.RegRead ("HKCU\Software\RIT\The Bat!\EXE path")
batVersion = fso.GetFileVersion(BatPath)
batBaseName = fso.GetBaseName(BatPath)
' Call MsgBox ("exe Path: " & BatPath & vbCrLf _
'            & "Version:  " & batVersion & vbCrLf _
'            & "Base name:" & batBaseName & vbCrLf _
'              , vbOKonly , "Info ber Bat Executable")
Name_Logfile = batBaseName & suffix_Logfile & extension_Logfile
If testModus Then
  Call MsgBox (EnviroUser("EMAIL"), vbOKonly, "Die EMAIL User-Variable")
Else
 Shello.CurrentDirectory = EnviroUser("EMAIL")  
End If 

If Not fso.fileExists (Name_Logfile) Then
	Call MsgBox("kein/no " & Name_Logfile & ".log in " & Shello.CurrentDirectory, vbOKonly, "nothing to do - ZIP-TB-Exceptions mu abbrechen")
Else 
  Set logfile = fso.GetFile(Name_Logfile)
  
  tagCreate = DateValue(logfile.DateCreated)
  zeitCreate = TimeValue(logfile.DateCreated)
  tagChange = DateValue(logfile.DateLastModified)
  zeitChange = TimeValue(logfile.DateLastModified)
  
' discarded version with dashes between the elements of the time stamp
'   zeitstempelCreate = Year(tagCreate) & "-" & Right("0" & Month(tagCreate),2) & "-" & Right("0" & Day(tagCreate),2) _
'       & "_" & Right("0" & Hour(zeitCreate),2) & "-" & Right("0" & Minute(zeitCreate),2) & "-" & Right("0" & Second(zeitCreate),2)
'   zeitstempelChange = Year(tagChange) & "-" & Right("0" & Month(tagChange),2) & "-" & Right("0" & Day(tagChange),2) _
'       & "_" & Right("0" & Hour(zeitChange),2) & "-" & Right("0" & Minute(zeitChange),2) & "-" & Right("0" & Second(zeitChange),2)
' 
  zeitstempelCreate = Year(tagCreate) & Right("0" & Month(tagCreate),2) & Right("0" & Day(tagCreate),2) _
      & "T" & Right("0" & Hour(zeitCreate),2) & Right("0" & Minute(zeitCreate),2) & Right("0" & Second(zeitCreate),2)
  zeitstempelChange = Year(tagChange) & Right("0" & Month(tagChange),2) & Right("0" & Day(tagChange),2) _
      & "T" & Right("0" & Hour(zeitChange),2) & Right("0" & Minute(zeitChange),2) & Right("0" & Second(zeitChange),2)
      
  ZIPtarget = batBaseName & "_" & batVersion & "_Exceptions_" & zeitStempelCreate & "-" & zeitStempelChange & ".zip"
  cmdLine = "zip.exe -m " & ZIPtarget & " " & Name_Logfile & " ex_log.txt"
  ' debug: Call MsgBox (cmdLine, vbOKonly, "Ist was falsch an der 'cmdline'?")
  Call Shello.run (cmdLine, 1, True)  ' prefix this to see cmd window: "cmd /k " & 
  Call MsgBox(ZIPtarget, vbOKonly, "ZIP of Exception.log created in " & Shello.CurrentDirectory)
  
  Set logfile = Nothing
  Set fso = Nothing
  Set Shello = Nothing  
  Set EnviroUser = Nothing
End if 
' .............. end program ...................
